# Custom Layers

You can write your own custom layers, and integrate them into your Tensorleap model.

To set up your custom layer, open the [Integration Scripts](/user-interface/resources-management/integration-scripts.md) editor and add a class that describes your custom layer.\
\
Then, register your custom layer with the `@tensorleap_custom_layer` decorator to support your layer.\
\
For example, here we add a custom dense layer:

```python
from code_loader.inner_leap_binder.leapbinder_decorators import tensorleap_custom_layer

# This class must inherit from tf.keras.layers.Layer
@tensorleap_custom_layer(name='CustomDense')
class CustomDense(tf.keras.layers.Layer):
    def __init__(self, n, **args):
        super(CustomDense, self).__init__()
        self.n = n
        self.dense = tf.keras.layers.Dense(self.n)

    def call(self, inputs):
        return self.dense(inputs)

    def get_config(self):
        config = super().get_config()
        config.update({
            "n": self.n,
        })
        return config
```

Now, you can upload a model that includes these layers by following the [Import Model](/user-interface/project/versions/import-model.md) guide.


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.tensorleap.ai/tensorleap-integration/writing-integration-code/custom-layers.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
